const APP_DISPLAY_NAME = "Flashblock";
const APP_NAME = "flashblock";
const APP_PACKAGE = "/Ted Mielczarek,Ted Drake/flashblock";
const APP_VERSION = "1.3.0";
const APP_DEFAULTS = "Flashblock Defaults";

const APP_JAR_FILE = "flashblock.jar";
const APP_CONTENT_FOLDER = "content/flashblock/";

const APP_SUCCESS_MESSAGE = "Flash objects will now be replaced with a button that you can click on to view them.\n\n";

// start it all up
initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);

// get user's profile chrome directory
var chromef = getFolder("Profile", "chrome");
var prefDir = getFolder("Program", "defaults/pref")
// add jar file
var err = addFile(APP_PACKAGE, APP_VERSION, "chrome/" + APP_JAR_FILE, chromef, null, true);
if(err == SUCCESS) {
    err = addFile(APP_DEFAULTS, APP_VERSION, "defaults/preferences/flashblock.js", prefDir, "flashblock.js", true);
// on unixy platforms, global defaults directory is not writable! Ignore this error!
    if(err == ACCESS_DENIED || err == READ_ONLY) {
        err = SUCCESS;
    }
}

var movedUserContent = false;

if(err == SUCCESS) {
	var jar = getFolder(chromef, APP_JAR_FILE);
	registerChrome(CONTENT | PROFILE_CHROME, jar, APP_CONTENT_FOLDER);
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/en-US/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/nl-NL/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/it-IT/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/de-DE/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/fr-FR/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/pl-PL/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/ko-KR/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/pt-BR/'+APP_NAME+'/');
    registerChrome(LOCALE | PROFILE_CHROME, jar, 'locale/da-DK/'+APP_NAME+'/');
	err = performInstall();
	if(err == SUCCESS || err == REBOOT_NEEDED) {
		msg = APP_NAME + " " + APP_VERSION + " has been succesfully installed.\n"
			+APP_SUCCESS_MESSAGE
			+"Please restart your browser to enable flashblock.";
		if(movedUserContent) {
			msg += "\n!!WARNING!! Your old userContent.css was renamed to userContent-flashblock-backup.css!";
		}
		alert(msg);
	}
	else {
		alert("Install failed. Could not performInstall. Error code:" + err);
		cancelInstall(err);
	}
}
else {
	alert("Install failed. Could not addFile: " + APP_JAR_FILE + ". Error code:" + err);
	cancelInstall(err);
}
